/* tcpclose.c
    Copyright Acquisition group, GANIL Caen, France

    Fonction : Fermeture normale d'un socket.

    Syntaxe     : int TcpClose(sid_pt)

    Entree   : int *sid_pt, identificateur du socket a fermer.
*/

#define _TCPCLOSE_

#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <sys/types.h>

#ifdef __Lynx__
#include <socket.h>
#include <resource.h>
#include <time.h>
#else
#include <sys/socket.h>
#include <sys/resource.h>
#include <sys/time.h>
#endif

#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <signal.h>
#include <sys/times.h>

#ifndef __Lynx__
#include <sys/param.h>
#else
#include <param.h>
#endif

#include "TCP.h"
#include "TCP_err.h"

int TcpClose(int *sid_pt)
{
  shutdown(*sid_pt,2);

  if (close(*sid_pt) == -1)
  {
    return(R_TCP_CLOSE);
  }

  *sid_pt = -1;

  return(0);
}    
