

   if {![namespace exists ::R3B]} {namespace eval ::R3B {;#puts "created namespace ::R3B"}}

   if {![info exists ::R3B::ModuleMenu]} {set ::R3B::ModuleMenu [list localhost]}
   if {![info exists ::R3B::R3BHost]} {set ::R3B::R3BHost [first $::R3B::ModuleMenu]}

   if {![info exists ::R3B::TestMode]} {set rc [catch {set ::R3B::TestMode 0} m]}

    variable Rmsg ""
    variable Wmsg ""

    proc ReadR3BRegister {Addr}  {
        global errorCode errorInfo
        global MIDAS_XR3BAccessServer_Exists
        global XR3BAccessServerHost

# puts "ReadR3BRegister  Addr=[format \"0x%x\" $Addr]"
# return 0

  if {$::R3B::TestMode != 0} {
     variable R3BData
     if {![info exists R3BData($Addr)]} {set R3BData($Addr) 0xaaaa} 
     return [set R3BData($Addr)]
  }

        if {[info exists MIDAS_XR3BAccessServer_Exists]} {
# puts "ReadR3BRegister do_Get"
            set rc [catch {interp eval "" ::namespace inscope ::urn:XR3BAccessServer do_Get $Addr} m]
        } else {
            if {$XR3BAccessServerHost != $::R3B::R3B4K} {
                set XR3BAccessServerHost  $::R3B::R3B4K
# puts "ReadR3BRegister configure $XR3BAccessServerHost"
                XR3BAccessClient_Configure
            }
# puts "ReadR3BRegister  $XR3BAccessServerHost  XR3BAccessClient__Get"
            set rc [catch {XR3BAccessClient__Get $Addr} m]
        }
        if {$rc != 0} {
            InsertLog "Get returned with an error\n$m\n$errorCode\n$errorInfo"
#  puts "ReadR3BRegister returned with an error\n$m\n$errorCode\n$errorInfo"
            return -1
        } else {
#           InsertLog "Get Addr=[format \"0x%x\" $Addr] => $m [format \"0x%x\" $m]"
#  puts "Get Addr=[format \"0x%x\" $Addr] => $m [format \"0x%x\" $m]"
            return $m
        }
    }

    proc WriteR3BRegister {Addr Vl}  {
        global errorCode errorInfo
        global MIDAS_XR3BAccessServer_Exists
        global XR3BAccessServerHost

# puts "WriteR3BRegister  Vl=[format \"0x%x\" $Vl]  Addr=[format \"0x%x\" $Addr]"
# return 0

  if {$::R3B::TestMode != 0} {
     variable R3BData
     set R3BData($Addr) $Vl
     return
  }

        if {[info exists MIDAS_XR3BAccessServer_Exists]} {
# puts "WriteR3BRegister do_Set"
            set rc [catch {interp eval "" ::namespace inscope ::urn:XR3BAccessServer do_Set $Addr $Vl} m]
        } else {
            if {$XR3BAccessServerHost != $::R3B::R3B4K} {
                set XR3BAccessServerHost  $::R3B::R3B4K
# puts "WriteR3BRegister configure $XR3BAccessServerHost"
                XR3BAccessClient_Configure
            }
# puts "WriteR3BRegister XR3BAccessClient__Set"
            set rc [catch {XR3BAccessClient__Set $Addr $Vl} m]
        }
        if {$rc != 0} {
            InsertLog "Set returned with an error\n$m\n$errorCode\n$errorInfo"
            puts "WriteR3BRegister returned with an error\n$m\n$errorCode\n$errorInfo"
            return -1
        } else {
#            InsertLog "Set $Vl => Addr=[format \"0x%x\" $Addr] => $m [format \"0x%x\" $m]"
#            puts "WriteR3BRegister Set $Vl => Addr=[format \"0x%x\" $Addr] => $m [format \"0x%x\" $m]"
            return $m
        }
    }


    proc ReadR3BASICRegister {addr}  {
        global errorCode errorInfo
        global MIDAS_XR3BASICAccessServer_Exists
        global XR3BASICAccessServerHost

        set ch [expr $addr & 0x3ff]
        set asic [expr ($addr >> 10) & 255]
        set bus [expr ($addr >> 18) & 255]
        set Addr [expr ($bus << 18) + ($asic << 10) + $ch]

# puts "ReadR3BASICRegister  Addr=[format \"0x%x\" $Addr]"
# return 0

  if {$::R3B::TestMode != 0} {
     variable R3BASICData
     if {![info exists R3BASICData($addr)]} {set R3BASICData($Addr) 0xaaaa} 
     return [set R3BASICData($addr)]
  }

        if {[info exists MIDAS_XR3BASICAccessServer_Exists]} {
# puts "ReadR3BASICRegister do_Get"
            set rc [catch {interp eval "" ::namespace inscope ::urn:XR3BASICAccessServer do_Get $Addr} m]
        } else {
            if {$XR3BASICAccessServerHost != $::R3B::R3B4K} {
                set XR3BASICAccessServerHost  $::R3B::R3B4K
# puts "ReadR3BASICRegister configure $XR3BASICAccessServerHost"
                XR3BASICAccessClient_Configure
            }
# puts "ReadR3BASICRegister  $XR3BASICAccessServerHost  XR3BASICAccessClient__Get"
            set rc [catch {XR3BASICAccessClient__Get $Addr} m]
        }
        if {$rc != 0 || [first $m] != 1} {
            InsertLog "Get returned with an error\n$m\n$errorCode\n$errorInfo"
#  puts "ReadR3BASICRegister returned with an error\nrc=$rc $m\n$errorCode\n$errorInfo"
            return -1
        } else {
#            InsertLog "Get Addr=[format \"0x%x\" $Addr] => $m [format \"0x%x\" $m]"
#  puts "Get Addr=[format \"0x%x\" $Addr] => $m [format \"0x%x\" $m]"
            return [second $m]
        }
    }

    proc WriteR3BASICRegister {addr Vl}  {
        global errorCode errorInfo
        global MIDAS_XR3BASICAccessServer_Exists
        global XR3BASICAccessServerHost

        set ch [expr $addr & 0x3ff]
        set asic [expr ($addr >> 10) & 255]
        set bus [expr ($addr >> 18) & 255]
        set Addr [expr ($bus << 18) + ($asic << 10) + $ch]

# puts "WriteR3BASICRegister  Vl=[format \"0x%x\" $Vl]  Addr=[format \"0x%x\" $Addr]"
# return 0

  if {$::R3B::TestMode != 0} {
     variable R3BASICData
     set R3BASICData($addr) $Vl
     return
  }

        if {[info exists MIDAS_XR3BASICAccessServer_Exists]} {
# puts "WriteR3BASICRegister do_Set"
            set rc [catch {interp eval "" ::namespace inscope ::urn:XR3BASICAccessServer do_Set $Addr $Vl} m]
        } else {
            if {$XR3BASICAccessServerHost != $::R3B::R3B4K} {
                set XR3BASICAccessServerHost  $::R3B::R3B4K
# puts "WriteR3BASICRegister configure $XR3BASICAccessServerHost"
                XR3BASICAccessClient_Configure
            }
# puts "WriteR3BASICRegister XR3BASICAccessClient__Set"
            set rc [catch {XR3BASICAccessClient__Set $Addr $Vl} m]
        }
        if {$rc != 0} {
            InsertLog "Set returned with an error\n$m\n$errorCode\n$errorInfo"
            puts "WriteR3BASICRegister returned with an error\n$m\n$errorCode\n$errorInfo"
            return -1
        } else {
#            InsertLog "Set $Vl => Addr=[format \"0x%x\" $Addr] => $m [format \"0x%x\" $m]"
#            puts "WriteR3BASICRegister Set $Vl => Addr=[format \"0x%x\" $Addr] => $m [format \"0x%x\" $m]"
            return $m
        }
    }



