
   if {![namespace exists ::LyrTech]} {namespace eval ::LyrTech {;#puts "created namespace ::LyrTech"}}

   if {![info exists ::LyrTech::TestMode]} {set rc [catch {set ::LyrTech::TestMode 0} m]}


    global VHSADCAccessServerHost
    if {![info exists VHSADCAccessServerHost]} {set VHSADCAccessServerHost "Undefined"}
    global VHSADCAccessServerPort
    if {![info exists VHSADCAccessServerPort]} {set VHSADCAccessServerPort 8015}

    global MIDAS_VHSADCAccessServer_Exists
    if {[info exists MIDAS_VHSADCAccessServer_Exists]} {set MIDAS_VHSADCAccessServer_Exists "local"}

    global VHSADCCrate
    if {![info exists VHSADCCrate]} {set VHSADCCrate "internal"}

    variable Verbose 1
      
    variable Rmsg ""
    variable Wmsg ""

   proc SelectVHSADCCrate {vl} {

       set ::LyrTech::crateID $vl
       SetVHSADCCrate $vl

       set ::LyrTech::boardList [second [lindex $::LyrTech::VHSADCLayOut [lsearch $::LyrTech::crateList $::LyrTech::crateID]]]
       set ::LyrTech::boardID [first $::LyrTech::boardList]
   }

    proc SelectVHSADCBoard {vl} {set ::LyrTech::boardID $vl}

    proc SetVHSADCCrate {crate} {global VHSADCCrate; set VHSADCCrate $crate}
    proc GetVHSADCCrate {} {global VHSADCCrate; return $VHSADCCrate}

    proc ReadVHSADCFpgaRegister  {board offset}  {
        global errorCode errorInfo
        global MIDAS_VHSADCAccessServer_Exists
        global VHSADCAccessServerHost
        global VHSADCCrate
        variable Verbose
        variable Rmsg
        variable rc 0

  if {$::LyrTech::TestMode != 0} {
     variable VHSADCData
     if {![info exists VHSADCData($VHSADCCrate,$board,$offset)]} {set VHSADCData($VHSADCCrate,$board,$offset) 0xaaaa}
  InsertLog "ReadVHSADCFpgaRegister $VHSADCCrate,$board,$offset  reads  [set VHSADCData($VHSADCCrate,$board,$offset)]"
     return [set VHSADCData($VHSADCCrate,$board,$offset)]
  }

        if {[info exists MIDAS_VHSADCAccessServer_Exists]} {
            if {$Verbose != 0} {InsertLog "ReadVHSADCFpgaRegister Vhsadac16ReadFpgaReg  $board $offset"}
            set rc [catch {interp eval "" ::namespace inscope ::urn:VHSADCAccessServer do_Vhsadac16ReadFpgaReg $board $offset} Rmsg]
        } else {
            if {$VHSADCAccessServerHost != $VHSADCCrate} {
                set VHSADCAccessServerHost  $VHSADCCrate
                if {$Verbose != 0} {InsertLog "ReadVHSADCFpgaRegister configure $VHSADCAccessServerHost"}
                VHSADCAccessClient_Configure
            }
            if {$Verbose != 0} {InsertLog "ReadVHSADCFpgaRegister  $VHSADCAccessServerHost  VHSADCAccessClient__Vhsadac16ReadFpgaReg  $board $offset"}
            set rc [catch {VHSADCAccessClient__Vhsadac16ReadFpgaReg $board $offset} Rmsg]
        }
        if {$rc != 0} {
           InsertLog {"Vhsadac16ReadFpgaReg returned with an error\n$Rmsg\n$errorCode\n$errorInfo"}
           set rc $errorCode
           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
        } else {
           if {$Verbose != 0} {InsertLog "Vhsadac16ReadFpgaReg Board = $board; Offset=[format \"0x%x\" $offset] => $Rmsg [format \"0x%x\" $Rmsg]"}
           set rc $Rmsg
        }
        return $rc
    }

    proc WriteVHSADCFpgaRegister  {board offset vl}  {
        global errorCode errorInfo
        global MIDAS_VHSADCAccessServer_Exists
        global VHSADCAccessServerHost
       global VHSADCCrate
        variable Verbose
        variable rc 0
        variable Wmsg

  if {$::LyrTech::TestMode != 0} {
     variable VHSADCData
  InsertLog "WriteVHSADCFpgaRegister $VHSADCCrate,$board,$offset  writes  $vl"
     set VHSADCData($VHSADCCrate,$board,$offset) $vl
     return
  }

        if {[info exists MIDAS_VHSADCAccessServer_Exists]} {
            if {$Verbose != 0} {InsertLog "WriteVHSADCFpgaRegister VhsadacWriteFpgaReg $board $offset $vl"}
            set rc [catch {interp eval "" ::namespace inscope ::urn:VHSADCAccessServer do_Vhsadac16WriteFpgaReg $board $offset $vl} Wmsg]
        } else {
            if {$VHSADCAccessServerHost != $VHSADCCrate} {
                set VHSADCAccessServerHost  $VHSADCCrate
                if {$Verbose != 0} {InsertLog "WriteVHSADCFpgaRegister configure $VHSADCAccessServerHost"}
                VHSADCAccessClient_Configure
            }
            if {$Verbose != 0} {InsertLog "WriteVHSADCFpgaRegister  $VHSADCAccessServerHost  VHSADCAccessClient__Vhsadac16WriteFpgaReg"}
            set rc [catch {VHSADCAccessClient__Vhsadac16WriteFpgaReg $board $offset $vl} Wmsg]
        }
        if {$rc != 0} {
            InsertLog "Vhsadac16WriteFpgaReg returned with an error\n$Wmsg\n$errorCode\n$errorInfo"
            if {$Verbose != 0} {InsertLog "Vhsadac16WriteFpgaReg returned with an error\n$Wmsg\n$errorCode\n$errorInfo"}
            set rc $errorcode
            return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
        } else {
            if {$Verbose != 0} {InsertLog "Vhsadac16WriteFpgaReg Board = $board; Offset=[format \"0x%x\" $offset] $vl => $Wmsg [format \"0x%x\" $Wmsg]"}
            set rc $Wmsg
        }
        return $rc
    }

    proc ReadVHSADCUserRegister {chan reg} {
       set boardID [set ::LyrTech::boardID]

        set regvl [expr ($chan << 28) + ($reg << 16)]        ;#    build data for register
        set value [ReadVHSADCUserRegisters $boardID $regvl] 
        return $value
    }

    proc WriteVHSADCUserRegister {chan reg vl} {
       set boardID [set ::LyrTech::boardID]

        set regvl [expr ($chan << 28) + ($reg << 16) + $vl]        ;#    build data for register
        WriteVHSADCUserRegisters $boardID $regvl   
    }

    proc ReadVHSADCUserRegisters {board regvls} {
       global VHSADCCrate

      set rc {}
      foreach regvl $regvls {

         if {$::LyrTech::TestMode != 0} {
             variable VHSADCData
             if {![info exists VHSADCData($VHSADCCrate,$board,[expr ($regvl >> 16) & 0x0000ffff])]} {set VHSADCData($VHSADCCrate,$board,[expr ($regvl >> 16) & 0x0000ffff]) 0xaaaa}
 InsertLog "ReadVHSADCUserRegister $VHSADCCrate,$board,[expr ($regvl >> 16) & 0x0000ffff]  reads  [set VHSADCData($VHSADCCrate,$board,[expr ($regvl >> 16) & 0x0000ffff])]" 
             lappend rc [set VHSADCData($VHSADCCrate,$board,[expr ($regvl >> 16) & 0x0000ffff])]
          } else {
             lappend rc [__WriteVHSADCUserRegisters $board $regvl]
          }

      }

      return $rc
    }

    proc WriteVHSADCUserRegisters {board regvls} {
       global VHSADCCrate

       set rc {}
       foreach regvl $regvls {

          if {$::LyrTech::TestMode != 0} {
             variable VHSADCData
  InsertLog "WriteVHSADCUserRegister $VHSADCCrate,$board,[expr ($regvl >> 16) & 0x0000ffff]  writes  [expr $regvl & 0x0000ffff]"
             set VHSADCData($VHSADCCrate,$board,[expr ($regvl >> 16) & 0x0000ffff]) [expr $regvl & 0x0000ffff]
          } else {
             __WriteVHSADCUserRegisters $board $regvl
          }
       }

       return
    }

    proc __WriteVHSADCUserRegisters  {board regvl}  {
        global errorCode errorInfo
        global MIDAS_VHSADCAccessServer_Exists
        global VHSADCAccessServerHost
       global VHSADCCrate
        variable Verbose
        variable rc 0
        variable Wmsg

        if {[info exists MIDAS_VHSADCAccessServer_Exists]} {
# puts "WriteVHSADCUserRegisters do_VHSADCWriteUserRegs"
            set rc [catch {interp eval "" ::namespace inscope ::urn:VHSADCAccessServer do_VHSADCWriteUserRegs $board {$regvl}} Wmsg]
            set errorcode $rc
            set errorInfo $Wmsg
        } else {
            if {$VHSADCAccessServerHost != $VHSADCCrate} {
                set VHSADCAccessServerHost  $VHSADCCrate
# puts "WriteVHSADCUserRegisters configure $VHSADCAccessServerHost"
                VHSADCAccessClient_Configure
            }
# puts "WriteVHSADCUserRegisters  $VHSADCAccessServerHost  VHSADCAccessClient__WriteUserRegs"
            set rc [catch {VHSADCAccessClient__WriteUserRegs $board $regvl} Wmsg]
        }
        if {$rc != 0} {
            InsertLog "WriteUserRegs returned with an error\n$Wmsg\n$errorCode\n$errorInfo"
# puts "WriteVHSADCUserRegisters returned with an error\n$Wmsg\n$errorCode\n$errorInfo"
            set rc $errorcode
            return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
        } else {
            if {$Verbose != 0} {InsertLog "WriteUserRegs $board $regvl => $Wmsg [format \"0x%x\" $Wmsg]"}
# puts "WriteVHSADCUserRegisters $board $regvl => $Wmsg [format \"0x%x\" $Wmsg]"
            set rc $Wmsg
        }
        return $rc
    }

    proc  __ReadVHSADCUserRegisters  {board regvl}  {
        global errorCode errorInfo
        global MIDAS_VHSADCAccessServer_Exists
        global VHSADCAccessServerHost
       global VHSADCCrate
        variable Verbose
        variable Rmsg
        variable rc 0

        if {[info exists MIDAS_VHSADCAccessServer_Exists]} {
# puts "ReadVHSADCUserRegister $board $regvl"
            set rc [catch {interp eval "" ::namespace inscope ::urn:VHSADCAccessServer do_VHSADCReadUserRegs $board $regvl} Rmsg]
        } else {
            if {$VHSADCAccessServerHost != $VHSADCCrate} {
                set VHSADCAccessServerHost  $VHSADCCrate
# puts "ReadVHSADCUserRegisters configure $VHSADCAccessServerHost"
                VHSADCAccessClient_Configure
            }
# puts "ReadVHSADCUserRegister  $VHSADCAccessServerHost  VHSADCAccessClient__ReadUserReg"
            set rc [catch {VHSADCAccessClient__ReadUserRegs $board $regvl} Rmsg]
        }
        if {$rc != 0} {
            InsertLog "ReadUserReg returned with an error\n$Rmsg\n$errorCode\n$errorInfo"
# puts "ReadUserReg returned with an error\n$Rmsg\n$errorCode\n$errorInfo"
           set rc $errorCode
           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
        } else {
            if {$Verbose != 0} {InsertLog "ReadUserReg $board $regvl  => $Rmsg [format \"0x%x\" $Rmsg]"}
# puts "ReadUserReg $board $regvl => $Rmsg [format \"0x%x\" $Rmsg]"
            set rc $Rmsg
        }
        return $rc
    }

    proc ReadVHSADCCpldRegs {board}  {
        global errorCode errorInfo
        global MIDAS_VHSADCAccessServer_Exists
        global VHSADCAccessServerHost
        global VHSADCCrate
        variable Verbose
        variable Rmsg
        variable rc 0

  if {$::LyrTech::TestMode != 0} {return}

        if {[info exists MIDAS_VHSADCAccessServer_Exists]} {
            set rc [catch {interp eval "" ::namespace inscope ::urn:VHSADCAccessServer do_Vhsadac16GetCpldRegs $board} Rmsg]
        } else {
            if {$VHSADCAccessServerHost != $VHSADCCrate} {
                set VHSADCAccessServerHost  $VHSADCCrate
                VHSADCAccessClient_Configure
            }
            if {$Verbose != 0} {InsertLog "ReadVHSADCCpldRegs  $VHSADCAccessServerHost  VHSADCAccessClient__Vhsadac16GetCpldRegs  $board"}
            set rc [catch {VHSADCAccessClient__Vhsadac16GetCpldRegs $board} Rmsg]
            if {$Verbose != 0} {InsertLog "ReadVHSADCCpldRegs => rc=$rc $Rmsg"}
        }
        if {$rc != 0} {
           InsertLog {"$rc Vhsadac16GetCpldRegs returned with an error  rc=$rc\n$Rmsg\n$errorCode\n$errorInfo"}
           set rc $errorCode
           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
        } else {
           if {$Verbose != 0} {InsertLog "Vhsadac16GetCpldRegs Board = $board => $Rmsg"}
           set rc $Rmsg
        }
        return $rc
    }

    proc VHSADCInit  {}  {
        global errorCode errorInfo
        global MIDAS_VHSADCAccessServer_Exists
        global VHSADCAccessServerHost
        global VHSADCCrate
        variable Rmsg
        variable rc 0

  if {$::LyrTech::TestMode != 0} {return 0}

        if {[info exists MIDAS_VHSADCAccessServer_Exists]} {
            set rc [catch {interp eval "" ::namespace inscope ::urn:VHSADCAccessServer do_VHSADCInit} Rmsg]
        } else {
            if {$VHSADCAccessServerHost != $VHSADCCrate} {
                set VHSADCAccessServerHost  $VHSADCCrate
                VHSADCAccessClient_Configure
            }
            set rc [catch {VHSADCAccessClient__VHSADCInit} Rmsg]

        }
        if {$rc != 0} {
           set rc $errorCode
           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
        } else {
#            InsertLog "VHSADCInit => $Rmsg [format \"0x%x\" $Rmsg]"
            set rc $Rmsg
        }

        return $rc
    }

    proc VHSADCExit  {}  {
        global errorCode errorInfo
        global MIDAS_VHSADCAccessServer_Exists
        global VHSADCAccessServerHost
        global VHSADCCrate
        variable Rmsg
        variable rc 0

  if {$::LyrTech::TestMode != 0} {return}

        if {[info exists MIDAS_VHSADCAccessServer_Exists]} {
            set rc [catch {interp eval "" ::namespace inscope ::urn:VHSADCAccessServer do_VHSADCExit $board} Rmsg]
        } else {
            if {$VHSADCAccessServerHost != $VHSADCCrate} {
                set VHSADCAccessServerHost  $VHSADCCrate
                VHSADCAccessClient_Configure
            }
            set rc [catch {VHSADCAccessClient__VHSADCExit} Rmsg]
        }
        if {$rc != 0} {
           set rc $errorCode
           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
        } else {
            InsertLog "VHSADCExit => $Rmsg [format \"0x%x\" $Rmsg]"
            set rc $Rmsg
        }
        return $rc
    }





